/*"Supherb's" automatic rack based plant growing system with dynamic lighting and automatic watering. Before use, test the amount of water your particular solution (so water bottle+gravity 
 * or a resevior with pump) pump per second. Fill proper values in for the integers "small" "medium" and "large". This is the time the valves stay open. ALSO VERY IMPORTANT: check the moisture levels through
 * the serial monitor and fill in the according values in at the integers "lowlevel", "highlevel" and "midlevel". These are the values that communicate the amount of water that is needed at watering time. Make
 * sure to test this with the soil you are going to use.
*/

 #include <IRremote.h>

IRsend irsend;
int mPin[] = {0, 1, 2, 3}; // The four moisture sensors
int waterVal[] = {A0, A1, B0, B1};
int waterPer[] = {0, 1, 2, 3};
int rPin1 = 4;
int rPin2 = 5;
int ledPinH = 10;
int ledPinL = 11;
int upperLayer;
int lowerLayer;
int valHigh;
int valLow;
int highPin = 8;
int lowPin = 7;
int EMERGENCYLEVEL = 95;
int LOWLEVEL = 50;
int MIDLEVEL = 70;
int HIGHLEVEL = 85;
int cycle = 0;
int x = 0;
int UVPin = 6;
int ledPin = 2;
int harvestLed = 9;
int val1 = 0;
int resetPin = 13;
int morning = 8;
int evening = 20;
int hour;
int small;
int medium;
int large;
unsigned long current;
unsigned long currentTimeA;
unsigned long currentTimeB;
unsigned long currentTimeC;
unsigned long currentTimeD;
unsigned long currentTimeE;
unsigned long currentTimeF;
unsigned long currentTimeG;
unsigned long currentTimeH;
unsigned long currentTimeI;
unsigned long IR;
boolean water = true;
boolean waterL = true;
boolean on = false;
boolean interrupt = false;
boolean change = true;
boolean Stime = false;


void setup() {
  Serial.begin(9600);
  pinMode(5, INPUT);
  pinMode(rPin1, OUTPUT);
  pinMode(rPin2, OUTPUT);
  pinMode(ledPinL, OUTPUT);
  pinMode(ledPinH, OUTPUT);
  pinMode(ledPin, OUTPUT);
  pinMode(harvestLed, OUTPUT);
  pinMode(UVPin, OUTPUT);
  pinMode(resetPin, INPUT);
  pinMode(lowPin, INPUT);
  pinMode(highPin, INPUT);
  currentTimeI = millis();
}
void loop() {
  if (Serial.available() > 0) {
    hour = Serial.read();
    Serial.println(hour);
  }
  valHigh = digitalRead(highPin);
  valLow = digitalRead(lowPin);
  if (valHigh == 1 && interrupt == false) {
    digitalWrite(ledPinH, HIGH);
  } else {
    digitalWrite(ledPinH, LOW);
  }
  if (valLow == 1 && interrupt == false) {
    digitalWrite(ledPinL, HIGH);
  } else {
    digitalWrite(ledPinL, LOW);
  }

  if (millis() > currentTimeI + 750) {
    for (int i = 0; i < 4; i++) {
      waterVal[i] = analogRead(mPin[i]);
      waterPer[i] = map(waterVal[i], 250, 1023, 0, 100);
    }
    upperLayer = waterPer[0] + waterPer[1];
    upperLayer = upperLayer / 2;
    lowerLayer = waterPer[2] + waterPer[3];
    lowerLayer = lowerLayer / 2;
    Serial.print("UP");
    Serial.println(upperLayer);
    Serial.print("lOW");
    Serial.println(lowerLayer);
    Serial.println(valHigh);
    Serial.println(valLow);
    currentTimeI = millis();
  }
  if (cycle < 10) {
    if (hour >= morning && hour <= evening) {
      if (on == false) {
        digitalWrite(ledPin, HIGH);
        x = morning;
        on = true;
      }
      if (hour == x || hour == x + 1) {
        digitalWrite(ledPin, HIGH);
        for (int i = 0; i < 10; i++) {
          if (millis() - IR >= 2000) {
            irsend.sendNEC(0xF720DF, 32);  //RED
            IR = millis();
          }
        }
      }
      if (hour == x + 2 || hour == x + 3) {
        digitalWrite(ledPin, HIGH);
        for (int i = 0; i < 10; i++) {
          if (millis() - IR >= 2000) {
            irsend.sendNEC(0xF7609F, 32);  //BLUE
            IR = millis();
          }
        }
      }
      if (hour == x + 4 || hour == x + 5) {
        digitalWrite(ledPin, HIGH);
        digitalWrite(UVPin, HIGH); //UV
        for (int i = 0; i < 10; i++) {
          if (millis() - IR >= 2000) {
            irsend.sendNEC(0xF7A05F, 32); //GREEN
            IR = millis();
          }
        }
      }
      if (hour == x + 6 || hour == x + 7) {
        digitalWrite(ledPin, HIGH);
        digitalWrite(UVPin, HIGH); //UV
        for (int i = 0; i < 10; i++) {
          if (millis() - IR >= 2000) {
            irsend.sendNEC(0xF720DF, 32);  //RED
            IR = millis();
          }
        }
      }
      if (hour == x + 8 || hour == x + 9) {
        digitalWrite(ledPin, HIGH);
        digitalWrite(UVPin, HIGH); //UV
        for (int i = 0; i < 10; i++) {
          if (millis() - IR >= 2000) {
            irsend.sendNEC(0xF7609F, 32);  //BLUE
            IR = millis();
          }
        }

      }
      if (hour == x + 10 || hour == x + 11) {
        digitalWrite(ledPin, HIGH);
        digitalWrite(UVPin, LOW); //UV
        for (int i = 0; i < 10; i++) {
          if (millis() - IR >= 2000) {
            irsend.sendNEC(0xF7A05F, 32); //GREEN
            IR = millis();
          }
        }
      }
      if (hour >= x + 12) {
        digitalWrite(ledPin, LOW);
        digitalWrite(UVPin, LOW); //UV
        on = false;
      }
      cycle + 1;
    }
  }
  else if (cycle < 20) {
    if (hour >= morning && hour <= evening) {
      if (on == false) {
        digitalWrite(ledPin, HIGH);
        x = morning;
        on = true;
      }
      if (hour == x || hour == x + 1) {
        for (int i = 0; i < 10; i++) {
          if (millis() - IR >= 2000) {
            irsend.sendNEC(0xF7A05F, 32); //GREEN
            IR = millis();
          }
        }
      }
      if (hour == x + 2 || hour == x + 3) {
        digitalWrite(UVPin, HIGH); //UV
        for (int i = 0; i < 10; i++) {
          if (millis() - IR >= 2000) {
            irsend.sendNEC(0xF7609F, 32);  //BLUE
            IR = millis();
          }
        }
      }
      if (hour == x + 4 || hour == x + 5) {
        digitalWrite(UVPin, HIGH); //UV
        for (int i = 0; i < 10; i++) {
          if (millis() - IR >= 2000) {
            irsend.sendNEC(0xF720DF, 32);  //RED
            IR = millis();
          }
        }
      }
      if (hour == x + 6 || hour == x + 7) {
        digitalWrite(UVPin, HIGH); //UV
        for (int i = 0; i < 10; i++) {
          if (millis() - IR >= 2000) {
            irsend.sendNEC(0xF7609F, 32);  //BLUE
            IR = millis();
          }
        }
      }
      if (hour == x + 8 || hour == x + 9) {
        digitalWrite(UVPin, LOW); //UV
      }
      if (hour == x + 10 || hour == x + 11) {
        for (int i = 0; i < 10; i++) {
          if (millis() - IR >= 2000) {
            irsend.sendNEC(0xF720DF, 32);  //RED
            IR = millis();
          }
        }
      }
      if (hour == x + 12) {
        digitalWrite(ledPin, LOW);
        on = false;
      }
      cycle + 1;
    }
  }
  else {
    if (hour >= morning && hour <= evening) {
      if (on == false) {
        digitalWrite(ledPin, HIGH);
        x = morning;
        on = true;
      }
      if (hour == x) {
        for (int i = 0; i < 10; i++) {
          if (millis() - IR >= 2000) {
            irsend.sendNEC(0xF7A05F, 32); //GREEN
            IR = millis();
          }
        }
      }
      if (hour == x + 1) {
        for (int i = 0; i < 10; i++) {
          if (millis() - IR >= 2000) {
            irsend.sendNEC(0xF7609F, 32);  //BLUE
            IR = millis();
          }
        }
      }
      if (hour == x + 2 || hour == x + 3) {
        digitalWrite(UVPin, HIGH); //UV
        for (int i = 0; i < 10; i++) {
          if (millis() - IR >= 2000) {
            irsend.sendNEC(0xF720DF, 32);  //RED
            IR = millis();
          }
        }
      }
      if (hour == x + 4 || hour == x + 5) {
        digitalWrite(UVPin, HIGH); //UV
        for (int i = 0; i < 10; i++) {
          if (millis() - IR >= 2000) {
            irsend.sendNEC(0xF7609F, 32);  //BLUE
            IR = millis();
          }
        }
      }
      if (hour == x + 6 || hour == x + 7) {
        digitalWrite(UVPin, HIGH); //UV
        for (int i = 0; i < 10; i++) {
          if (millis() - IR >= 2000) {
            irsend.sendNEC(0xF720DF, 32);  //RED
            IR = millis();
          }
        }
      }
      if (hour == x + 8 || hour == x + 9 || hour == x + 10 || hour == x + 11) {
        digitalWrite(UVPin, HIGH); //UV
        for (int i = 0; i < 10; i++) {
          if (millis() - IR >= 2000) {
            irsend.sendNEC(0xF7609F, 32);  //BLUE
            IR = millis();
          }
        }
      }
      if (hour == x + 12) {
        digitalWrite(ledPin, LOW);
        digitalWrite(UVPin, LOW); //UV
        on = false;
      }
      cycle + 1;
    }
  }
  if (cycle > 30) {
    digitalWrite(harvestLed, HIGH);
  }
  val1 = digitalRead(resetPin);
  if (val1 == 1) {
    digitalWrite(harvestLed, LOW);
    cycle = 0;
  }



  //VERSION 1 of the watering system, there are 2 main watering points in the day, in the morning at 0900 and in the afternoon at 1800.
  //With the sensor data we try to approximate the amount of water the plant needs at the watering moment.

  //For the upper level
  if (hour == morning && water == true && valHigh == 0 || hour == evening && water == true && valHigh == 0) {
    if (upperLayer >= LOWLEVEL && upperLayer < MIDLEVEL) {
      digitalWrite(rPin1, HIGH);
      currentTimeA = millis();
      if (millis() - currentTimeA == small) {
        digitalWrite(rPin1, LOW);
        water = false;
      }
    }
    if (upperLayer >= MIDLEVEL && upperLayer < HIGHLEVEL) {
      digitalWrite(rPin1, HIGH);
      currentTimeB = millis();
      if (millis() - currentTimeB == medium) {
        digitalWrite(rPin1, LOW);
        water = false;
      }
    }
    if (upperLayer >= HIGHLEVEL && upperLayer < 101) {
      digitalWrite(rPin1, HIGH);
      currentTimeC = millis();
      if (millis() - currentTimeC == large) {
        digitalWrite(rPin1, LOW);
        water = false;
      }
    }
  }

  //For the lower level
  if (hour == morning && waterL == true && valLow == 0 || hour == evening && waterL == true && valLow == 0) {
    if (lowerLayer >= LOWLEVEL && lowerLayer < MIDLEVEL) {
      digitalWrite(rPin2, HIGH);
      Stime = true;
      if (Stime == true) {
        currentTimeD = millis();
        Stime = false;
      }
      currentTimeD = millis();
      if (millis() - currentTimeD == small) {
        digitalWrite(rPin2, LOW);
        waterL = false;
      }
    }
    if (lowerLayer >= MIDLEVEL && lowerLayer < HIGHLEVEL) {
      digitalWrite(rPin2, HIGH);
      currentTimeE = millis();
      if (millis() - currentTimeE == medium) {
        digitalWrite(rPin2, LOW);
        waterL = false;
      }
    }
    if (lowerLayer >= HIGHLEVEL && lowerLayer < 101) {
      digitalWrite(rPin2, HIGH);
      currentTimeF = millis();
      if (millis() - currentTimeF == large) {
        digitalWrite(rPin2, LOW);
        waterL = false;
      }
    }
  }

  if (hour == (morning - 1)  || hour == (evening - 1)) {
    water = true;

  }
}
